// C2HtmDlg.cpp : implementation file
//

#include "stdafx.h"
#include <io.h>
#include "C2Htm.h"
#include "C2HtmDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CC2HtmDlg dialog

CC2HtmDlg::CC2HtmDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CC2HtmDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CC2HtmDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CC2HtmDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CC2HtmDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CC2HtmDlg, CDialog)
	//{{AFX_MSG_MAP(CC2HtmDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PROFILE_LOAD, OnProfileLoad)
	ON_BN_CLICKED(IDC_PROFILE_DEFAULTS, OnProfileDefaults)
	ON_BN_CLICKED(IDC_PROFILE_SAVE, OnProfileSave)
	ON_BN_CLICKED(IDC_MAKE_DEFAULT_PROFILE, OnMakeDefaultProfile)
	ON_BN_CLICKED(IDC_CONVERT, OnConvert)
	ON_CBN_SELENDOK(IDC_AVAIL_PROFILES, OnSelendokAvailProfiles)
	ON_BN_CLICKED(IDC_PROFILE_DELETE, OnProfileDelete)
	ON_BN_CLICKED(IDC_VIEW_CSS, OnViewCss)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CC2HtmDlg message handlers

BOOL CC2HtmDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	m_font.CreateFont(14, 0, 0, 0, 400, false, false, false,
		ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
		DEFAULT_QUALITY, DEFAULT_PITCH | FF_SWISS, "Courier");
	GetDlgItem(IDC_CODE)->SetFont(&m_font);

	m_b_first_time = true;

	((CButton*)GetDlgItem(IDC_HTML_CORRECT))->SetCheck(true);

	LoadProfiles();
	OnProfileLoad();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

int CC2HtmDlg::LoadProfiles()
{
	CComboBox *p_box = (CComboBox*)GetDlgItem(IDC_AVAIL_PROFILES);
	TProfileName t_name;
	int n_profile_num;
	char p_s_str[64];
	CParser parser;
	FILE *p_fr;
	int i, n;

	m_n_default_profile = 0;
	p_box->Clear();
	m_profile_list.Clear();
	if((p_fr = fopen("profiles.ini", "r"))) {
		if(parser.Parse(p_fr) != Parser_Ok) {
			MessageBox("Error in main ini file !", "C2Htm", MB_OK | MB_ICONERROR);
			return false;
		}
		fclose(p_fr);

		if(parser.GetValue("n_profile_num", n_profile_num) != Parser_Ok) {
			MessageBox("Error in main ini file !", "C2Htm", MB_OK | MB_ICONERROR);
			return false;
		}

		for(i = 0; i < n_profile_num; i ++) {
			sprintf(p_s_str, "p_profile_name[%d].p_s_name", i);
			if(parser.GetStrLength(p_s_str, n) != Parser_Ok) {
				MessageBox("Error in main ini file !", "C2Htm", MB_OK | MB_ICONERROR);
				return false;
			}
			if(!(t_name.p_s_profile_name = new char[++ n])) {
				MessageBox("Not enough memory", "C2Htm", MB_OK | MB_ICONERROR);
				return false;
			}
			if(parser.GetValue(p_s_str, t_name.p_s_profile_name, n) != Parser_Ok) {
				MessageBox("Error in main ini file !", "C2Htm", MB_OK | MB_ICONERROR);
				return false;
			}
			//
			sprintf(p_s_str, "p_profile_name[%d].p_s_file_name", i);
			if(parser.GetStrLength(p_s_str, n) != Parser_Ok) {
				MessageBox("Error in main ini file !", "C2Htm", MB_OK | MB_ICONERROR);
				return false;
			}
			if(!(t_name.p_s_profile_file = new char[++ n])) {
				MessageBox("Not enough memory", "C2Htm", MB_OK | MB_ICONERROR);
				return false;
			}
			if(parser.GetValue(p_s_str, t_name.p_s_profile_file, n) != Parser_Ok) {
				MessageBox("Error in main ini file !", "C2Htm", MB_OK | MB_ICONERROR);
				return false;
			}
			// pete jmno profilu ...

			if(!m_profile_list.Insert_Element(&t_name, 1)) {
				MessageBox("Not enough memory", "C2Htm", MB_OK | MB_ICONERROR);
				return false;
			}
			p_box->AddString(t_name.p_s_profile_name);
			// pid profil do seznamu ...
		}

		if(m_n_default_profile >= 0 && m_profile_list.p_Element(m_n_default_profile)) {
			if(parser.GetValue("n_default_profile", m_n_default_profile) != Parser_Ok) {
				MessageBox("Error in main ini file !", "C2Htm", MB_OK | MB_ICONERROR);
				return false;
			}
			p_box->SelectString(0,
				m_profile_list.p_Element(m_n_default_profile)->p_s_profile_name);
		}
		// default profile

		parser.Free();
	} else {
		if((p_fr = fopen("profiles.ini", "w"))) {
			fprintf(p_fr, "// C2Htm profile config by -tHE SWINe- (luki.sach@atlas.cz)\n//\n//"
				" here profile name/file settings are stored\n//\n\nn_profile_num = 0;\nn_default_profile = -1;\n\n// end of file");
			fclose(p_fr);
		}
	}
	// pete profile.ini

	t_name.p_s_profile_file = 0;
	t_name.p_s_profile_name = 0;
	// nechci aby mi to uvolnilo ty posledn hodnoty !!

	return true;
}

int CC2HtmDlg::SaveProfiles()
{
	FILE *p_fw;
	int i;

	if(!(p_fw = fopen("profiles.ini", "w")))
		return false;

	fprintf(p_fw, "// C2Htm profile config by -tHE SWINe-"
		" (luki.sach@atlas.cz)\n//\n// here profile name/"
		"file settings are stored\n//\n\nn_profile_num = "
		"%d;\nn_default_profile = %d;\n", m_profile_list.n_Element_Num(), m_n_default_profile);
	// zape poet profil a defaultn profil ...

	for(i = 0; i < m_profile_list.n_Element_Num(); i ++) {
		fprintf(p_fw, "p_profile_name[%d].p_s_name = \"%s\";\n",
			i, m_profile_list.p_Element(i)->p_s_profile_name);
		fprintf(p_fw, "p_profile_name[%d].p_s_file_name = \"%s\";\n",
			i, m_profile_list.p_Element(i)->p_s_profile_file);
	}
	// zape jmna profil ...

	fprintf(p_fw, "\n// end of file");
	fclose(p_fw);

	return true;
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CC2HtmDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
		if(m_b_first_time) {
			((CEdit*)GetDlgItem(IDC_CODE))->SetFocus();
			m_b_first_time = false;
		}
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CC2HtmDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CC2HtmDlg::OnCancel() 
{
	CDialog::OnCancel();
}

void CC2HtmDlg::OnOK() 
{/*CDialog::OnOK();*/}

void CC2HtmDlg::OnProfileDefaults() 
{
	SetDlgItemText(IDC_TAB_SIZE, "4");
	SetDlgItemText(IDC_COLOR_KEYWORD, "0000FF");
	SetDlgItemText(IDC_COLOR_COMMENT, "008000");
	//
	SetDlgItemText(IDC_COLOR_TABLE_LT, "A8C8E8");
	SetDlgItemText(IDC_COLOR_TABLE_DK, "4084D0");
	//
	SetDlgItemInt(IDC_FONT_SIZE, 13, true);
	//
	SetDlgItemText(IDC_TABLE_WIDTH, "80");
	((CButton*)GetDlgItem(IDC_TABLE_PERCENT))->SetCheck(true);
	//
	((CButton*)GetDlgItem(IDC_TABLE))->SetCheck(true);
	//
	SetDlgItemText(IDC_KEYWORDS, "# #define #undef #defined #include"
		" #pragma #if #else #elif #endif #ifdef #ifndef asm auto"
		" break case catch char class const continue default delete"
		" do double else enum extern float for friend goto if inline"
		" int long new operator private protected public register"
		" return short signed sizeof static struct switch template"
		" this throw try typedef union unsigned virtual void volatile"
		" while");
	// nastav hodnoty, odpovdajc C++
}

void CC2HtmDlg::GetProfile(TProfile *p_profile)
{
	CString str;

	p_profile->n_table_width = GetDlgItemInt(IDC_TABLE_WIDTH, 0, true);
	p_profile->b_table_width_percent = ((CButton*)GetDlgItem(IDC_TABLE_PERCENT))->GetCheck();
	//
	p_profile->b_use_table = ((CButton*)GetDlgItem(IDC_TABLE))->GetCheck();
	//
	p_profile->n_tab_size = GetDlgItemInt(IDC_TAB_SIZE, 0, true);
	p_profile->n_font_size = GetDlgItemInt(IDC_FONT_SIZE, 0, true);
	//
	GetDlgItemText(IDC_COLOR_COMMENT, str);
	p_profile->Set_CommentColor(str.GetBuffer(0));
	GetDlgItemText(IDC_COLOR_KEYWORD, str);
	p_profile->Set_KeywordColor(str.GetBuffer(0));
	//
	GetDlgItemText(IDC_COLOR_TABLE_LT, str);
	p_profile->Set_TableLtColor(str.GetBuffer(0));
	GetDlgItemText(IDC_COLOR_TABLE_DK, str);
	p_profile->Set_TableDkColor(str.GetBuffer(0));
	//
	GetDlgItemText(IDC_KEYWORDS, str);
	if(!p_profile->Set_Keywords(str.GetBuffer(0))) {
		MessageBox("Not enough memory", "C2Htm", MB_OK | MB_ICONERROR);
		return;
	}
	// vytvo profil ...
}

void CC2HtmDlg::SetProfile(TProfile *p_profile)
{
	char *p_s_str;

	SetDlgItemInt(IDC_TABLE_WIDTH, p_profile->n_table_width, true);
	((CButton*)GetDlgItem(IDC_TABLE_PERCENT))->SetCheck(p_profile->b_table_width_percent);
	//
	((CButton*)GetDlgItem(IDC_TABLE))->SetCheck(p_profile->b_use_table);
	//
	SetDlgItemInt(IDC_TAB_SIZE, p_profile->n_tab_size, true);
	SetDlgItemInt(IDC_FONT_SIZE, p_profile->n_font_size, true);
	//
	if(!(p_s_str = p_profile->p_s_CommentColor())) {
		MessageBox("Not enough memory !", "C2Htm", MB_OK | MB_ICONERROR);
		return;
	}
	SetDlgItemText(IDC_COLOR_COMMENT, p_s_str);
	delete[] p_s_str;
	//
	if(!(p_s_str = p_profile->p_s_KeywordColor())) {
		MessageBox("Not enough memory !", "C2Htm", MB_OK | MB_ICONERROR);
		return;
	}
	SetDlgItemText(IDC_COLOR_KEYWORD, p_s_str);
	delete[] p_s_str;
	//
	if(!(p_s_str = p_profile->p_s_TableLtColor())) {
		MessageBox("Not enough memory !", "C2Htm", MB_OK | MB_ICONERROR);
		return;
	}
	SetDlgItemText(IDC_COLOR_TABLE_LT, p_s_str);
	delete[] p_s_str;
	//
	if(!(p_s_str = p_profile->p_s_TableDkColor())) {
		MessageBox("Not enough memory !", "C2Htm", MB_OK | MB_ICONERROR);
		return;
	}
	SetDlgItemText(IDC_COLOR_TABLE_DK, p_s_str);
	delete[] p_s_str;
	//
	if(!(p_s_str = p_profile->p_s_Keywords())) {
		MessageBox("Not enough memory !", "C2Htm", MB_OK | MB_ICONERROR);
		return;
	}
	SetDlgItemText(IDC_KEYWORDS, p_s_str);
	delete[] p_s_str;
}

void CC2HtmDlg::OnProfileLoad() 
{
	TProfile t_profile;
	CString str;
	int i;

	GetDlgItemText(IDC_AVAIL_PROFILES, str);
	for(i = 0; i < m_profile_list.n_Element_Num(); i ++) {
		if(!stricmp(str.GetBuffer(0), m_profile_list.p_Element(i)->p_s_profile_name)) {
			if(!t_profile.Load(m_profile_list.p_Element(i)->p_s_profile_file)) {
				MessageBox("Error loading profile !", "C2Htm", MB_OK | MB_ICONERROR);
				return;
			}
			break;
		}
	}
	if(i == m_profile_list.n_Element_Num()) {
		MessageBox("Can't find profile !", "C2Htm", MB_OK | MB_ICONERROR);
		return;
	}
	// load profile ...

	SetProfile(&t_profile);
	// d profil do formule ...
}

void CC2HtmDlg::OnProfileSave() 
{
	TProfileName t_name;
	TProfile t_profile;
	CComboBox *p_box;
	CString str;
	int i;

	GetProfile(&t_profile);
	// nahraje profil z formule ...

	GetDlgItemText(IDC_AVAIL_PROFILES, str);
	for(i = 0; i < m_profile_list.n_Element_Num(); i ++) {
		if(!stricmp(str.GetBuffer(0), m_profile_list.p_Element(i)->p_s_profile_name)) {
			str = m_profile_list.p_Element(i)->p_s_profile_file;
			break;
		}
	}
	if(i == m_profile_list.n_Element_Num()) {
		if(!(t_name.p_s_profile_name = new char[str.GetLength() + 1])) {
			MessageBox("Not enough memory", "C2Htm", MB_OK | MB_ICONERROR);
			return;
		}
		strcpy(t_name.p_s_profile_name, str.GetBuffer(0));
		//
		do {
			str.Format("profile_%08x.ini", rand());
		} while(_access(str.GetBuffer(0), 0) != -1);
		if(!(t_name.p_s_profile_file = new char[str.GetLength() + 1])) {
			MessageBox("Not enough memory", "C2Htm", MB_OK | MB_ICONERROR);
			return;
		}
		strcpy(t_name.p_s_profile_file, str.GetBuffer(0));
		//
		if(!(m_profile_list.Insert_Element(&t_name, 1))) {
			MessageBox("Not enough memory", "C2Htm", MB_OK | MB_ICONERROR);
			return;
		}
		//
		p_box = (CComboBox*)GetDlgItem(IDC_AVAIL_PROFILES);
		p_box->AddString(t_name.p_s_profile_name);
		//
		t_name.p_s_profile_name = 0;
		t_name.p_s_profile_file = 0;
		//
		SaveProfiles();
	}
	// get unique profile name

	if(!t_profile.Save(str.GetBuffer(0)))
		MessageBox("Error saving profile !", "C2Htm", MB_OK | MB_ICONERROR);
}

void CC2HtmDlg::OnMakeDefaultProfile() 
{
	CString str;
	int i;

	GetDlgItemText(IDC_AVAIL_PROFILES, str);
	for(i = 0; i < m_profile_list.n_Element_Num(); i ++) {
		if(!stricmp(str.GetBuffer(0), m_profile_list.p_Element(i)->p_s_profile_name)) {
			m_n_default_profile = i;
			break;
		}
	}
	if(i == m_profile_list.n_Element_Num())
		return;

	OnProfileLoad();
	SaveProfiles();
}

void CC2HtmDlg::OnProfileDelete() 
{
	char p_s_str[256];
	CString str;
	int i;

	GetDlgItemText(IDC_AVAIL_PROFILES, str);

	sprintf(p_s_str, "Do you really want to delete profile named \'%s\' ?", str.GetBuffer(0));
	if(MessageBox(p_s_str, "C2Htm", MB_YESNO | MB_ICONQUESTION) == IDNO)
		return;
	// zept se hestli chci smazat takovej profil ...

	for(i = 0; i < m_profile_list.n_Element_Num(); i ++) {
		if(!stricmp(str.GetBuffer(0), m_profile_list.p_Element(i)->p_s_profile_name)) {
			if(m_n_default_profile == i)
				m_n_default_profile = 0;
			if(!m_profile_list.Remove_Element(i, 1)) {
				MessageBox("Error deleting profile !", "C2Htm", MB_OK | MB_ICONERROR);
				return;
			}
			i = -1;
			break;
		}
	}
	if(i == m_profile_list.n_Element_Num())
		return;

	SaveProfiles();

	MessageBox("Profile succesfully erased !\nIn case you needed "
		"it again, you can find it's .ini file and activate it manually.",
		"C2Htm", MB_OK | MB_ICONINFORMATION);
	// profil se smae jen ze seznamu, ini zstv ...

	LoadProfiles();
	
}

void CC2HtmDlg::OnSelendokAvailProfiles() 
{
	OnProfileLoad();
	// bl..
}

struct {
	char c_original;
	char p_s_tag[256];
} p_special_char[] = { {'\t', "\t"}, // tab mus bt prvn !!!!
					   {'>', "&gt;"},
					   {'<', "&lt;"},
					   {'&', "&amp;"}};
// special html chars ...

int __cdecl cmpStrings(const void *p_stra, const void *p_strb)
{
	return (signed)strlen(*((const char**)p_strb)) - (signed)strlen(*((const char**)p_stra));
}

void CC2HtmDlg::OnConvert() 
{
	CProgressCtrl *p_progress = (CProgressCtrl*)GetDlgItem(IDC_PROGRESS);
	CString str_begin_comment, str_end_comment;
	CString str_begin_keyword, str_end_keyword;
	int b_finish_comment_after_whitespace;
	int b_finish_keyword_after_whitespace;
	int b_in_singleline_comment;
	int b_in_begin_end_comment;
	CString str_in, str_out;
	TProfile t_profile;
	int n_next_chars;
	int b_in_string;
	int i, j, n;
	int b_w3c;

	BeginWaitCursor();

	p_progress->SetRange(0, 1024);
	p_progress->SetPos(0);

	GetProfile(&t_profile);
	// nahraje profil z formule ...

	b_w3c = ((CButton*)GetDlgItem(IDC_HTML_CORRECT))->GetCheck();
	// zjist, jestli chci w3c

	qsort(t_profile.t_keyword_list.p_Element(0),
		t_profile.t_keyword_list.n_Element_Num(), sizeof(char*), cmpStrings);
	// sead keywords podle dlky

	if(b_w3c) {
		if(t_profile.b_use_table) {
			str_out.Format("<table cellspacing=\"0\" class=\"cpp\" "
				"align=\"center\" cellpadding=\"10\" width=\"%d", t_profile.n_table_width);
			if(t_profile.b_table_width_percent)
				str_out += "%";
			str_out += "\" border=\"2\"><tr><td><pre>\r\n<code class=\"cpp_text\">\r\n";
		} else
			str_out = "<pre class=\"cpp\"><code class=\"cpp_text\">";
		//
		str_begin_comment = "<code class=\"cpp_comment\">";
		str_begin_keyword = "<code class=\"cpp_keyword\">";
		str_end_comment = "</code>";
		str_end_keyword = "</code>";
	} else {
		if(t_profile.b_use_table) {
			str_out.Format("<table cellspacing=\"0\" bordercolorlight=\"#%06X\""
				" bordercolordark=\"#%06x\" align=\"center\" cellpadding=\"10\" width=\"%d",
				t_profile.n_table_lt_color, t_profile.n_table_dk_color, t_profile.n_table_width);
			if(t_profile.b_table_width_percent)
				str_out += "%";
			str_out += "\" border=\"2\"><tr><td><pre>\r\n\r\n";
		} else
			str_out = "<pre>\r\n";
		//
		str_begin_comment.Format("<font color=\"#%06X\">", t_profile.n_comment_color);
		str_begin_keyword.Format("<font color=\"#%06X\">", t_profile.n_keyword_color);
		str_end_comment = "</font>";
		str_end_keyword = "</font>";
	}
	// naformtuje si stringy ...

	if(t_profile.n_tab_size < 0)
		MessageBox("Negative tab-size = keep tabs", "C2Htm", MB_OK | MB_ICONINFORMATION);
	else {
		if(t_profile.n_tab_size > 255) {
			MessageBox("Max tab-size is 255 !", "C2Htm", MB_OK | MB_ICONERROR);
			t_profile.n_tab_size = 255;
		}
		//
		memset(p_special_char[0].p_s_tag, ' ', t_profile.n_tab_size);
		p_special_char[0].p_s_tag[t_profile.n_tab_size] = 0;
	}
	// handle tab_size

	GetDlgItemText(IDC_CODE, str_in);
	for(i = 0; i < str_in.GetLength(); i ++) {
		for(j = 0; j < sizeof(p_special_char) / sizeof(p_special_char[0]); j ++) {
			if(str_in[i] == p_special_char[j].c_original) {
				str_out += p_special_char[j].p_s_tag;
				break;
			}
		}
		if(j == sizeof(p_special_char) / sizeof(p_special_char[0]))
			str_out += str_in[i];

		if((i & 255) == 0)
			p_progress->SetPos((i * 512) / str_in.GetLength());
	}
	// odstran nebezpen znaky ...

	SetDlgItemText(IDC_CODE, str_out);
	// zkopruje, a je vidt e to nco dl ...

	str_in = str_out;
	str_out = "";
	//
	b_in_singleline_comment = false;
	b_in_begin_end_comment = false;
	b_in_string = false;
	//
	b_finish_comment_after_whitespace = false;
	b_finish_keyword_after_whitespace = false;
	//
	for(i = 0, str_out = ""; i < str_in.GetLength(); i ++) {
		if((i & 255) == 0)
			p_progress->SetPos(512 + (i * 512) / str_in.GetLength());

		n_next_chars = str_in.GetLength() - i - 1;
		//
		if(!b_in_singleline_comment && !b_in_begin_end_comment) {
			if(str_in[i] == '\"' && (!i || (i && (str_in[i - 1] != '\\'))))
				b_in_string = !b_in_string;
		}
		// oeten string ...

		if(!b_in_string && !b_in_begin_end_comment && !b_in_singleline_comment) {
			if(str_in[i] == '/' && n_next_chars && str_in[i + 1] == '/') {
				if(!b_finish_comment_after_whitespace)
					str_out += str_begin_comment;
				b_in_singleline_comment = true;
				b_finish_comment_after_whitespace = false;
			}
		}
		if(b_in_singleline_comment && str_in[i] == '\n') {
			b_in_singleline_comment = false;
			b_finish_comment_after_whitespace = true;
		}
		// koment na 1 dek ...

		if(!b_in_string && !b_in_singleline_comment) {
			if(str_in[i] == '/' && n_next_chars && str_in[i + 1] == '*' && !b_in_begin_end_comment) {
				if(!b_finish_comment_after_whitespace)
					str_out += str_begin_comment;
				//
				b_in_begin_end_comment = true;
				b_finish_comment_after_whitespace = false;
			}
			if(str_in[i] == '*' && n_next_chars && str_in[i + 1] == '/') {
				b_finish_comment_after_whitespace = b_in_begin_end_comment;
				b_in_begin_end_comment = false;
				//
				i ++;
				str_out += "*/";
				//
				continue;
			}
		}
		// multitline koment ...

		if(b_finish_comment_after_whitespace && str_in[i] != ' ' &&
		   str_in[i] != '\t' && str_in[i] != '\n' && str_in[i] != '\r') {
			str_out += str_end_comment;
			b_finish_comment_after_whitespace = false;
		}
		// ukonen komente ...

		if(!b_in_singleline_comment && !b_in_begin_end_comment && !b_in_string) {
			if((i && (str_in[i - 1] == ' ' || str_in[i - 1] == '\t' ||
					  str_in[i - 1] == '\n' || str_in[i - 1] == '\r' ||
					  str_in[i - 1] == '[' || str_in[i - 1] == ']' ||
					  str_in[i - 1] == '(' || str_in[i - 1] == ')' ||
					  str_in[i - 1] == '+' || str_in[i - 1] == '-' ||
					  str_in[i - 1] == '*' || str_in[i - 1] == '/' ||
					  str_in[i - 1] == '<' || str_in[i - 1] == '>' ||
					  str_in[i - 1] == '&' ||//  // &lt; / &gt;
					  str_in[i - 1] == '.' || str_in[i - 1] == ',' ||
					  str_in[i - 1] == ';' || str_in[i - 1] == '~' ||
					  str_in[i - 1] == ':' || str_in[i - 1] == '?')) || i == 0) {
				for(j = 0; j < t_profile.t_keyword_list.n_Element_Num(); j ++) {
					if(!strncmp(str_in.GetBuffer(0) + i,
					   *t_profile.t_keyword_list.p_Element(j),
					   n = strlen(*t_profile.t_keyword_list.p_Element(j)))) {
						//
						if(n_next_chars <= n || (n_next_chars > n &&
						   (str_in[i + n] == ' ' || str_in[i + n] == '\t' ||
						   str_in[i + n] == '\n' || str_in[i + n] == '\r' ||
						   str_in[i + n] == '[' || str_in[i + n] == ']' ||
						   str_in[i + n] == '(' || str_in[i + n] == ')' ||
						   str_in[i + n] == '+' || str_in[i + n] == '-' ||
						   str_in[i + n] == '*' || str_in[i + n] == '/' ||
						   str_in[i - 1] == '<' || str_in[i - 1] == '>' ||
						   str_in[i + n] == '&' ||// str_in[i + n] == '>' || // &lt; / &gt;
						   str_in[i + n] == '.' || str_in[i + n] == ',' ||
						   str_in[i + n] == ';' || str_in[i + n] == '~' ||
						   str_in[i + n] == ':' || str_in[i + n] == '?'))) {
							if(!b_finish_keyword_after_whitespace)
								str_out += str_begin_keyword;
							b_finish_keyword_after_whitespace = true;
							//
							str_out += *t_profile.t_keyword_list.p_Element(j);
							i += strlen(*t_profile.t_keyword_list.p_Element(j));
							//
							break;
						}
					}
				}
				if(j != t_profile.t_keyword_list.n_Element_Num()) {
					i --;
					continue;
				}
			}
		}
		// oeten keywords

		if(b_finish_keyword_after_whitespace && str_in[i] != ' ' &&
		   str_in[i] != '\t' && str_in[i] != '\n' && str_in[i] != '\r') {
			str_out += str_end_keyword;
			b_finish_keyword_after_whitespace = false;
		}
		// ukonen keywords ...

		str_out += str_in[i];
	}

	if(b_finish_comment_after_whitespace || b_in_singleline_comment || b_in_begin_end_comment)
		str_out += str_end_comment;
	if(b_finish_keyword_after_whitespace)
		str_out += str_end_keyword;
	// pokud je jet pod v komenti ...

	if(t_profile.b_use_table) {
		if(b_w3c)
			str_out += "\r\n</code></pre></td></tr></table>\r\n";
		else
			str_out += "\r\n</pre></td></tr></table>\r\n";
	} else {
		if(b_w3c)
			str_out += "\r\n</code></pre>\r\n";
		else
			str_out += "\r\n</pre>\r\n";
	}
	// ukon string ...

	if(str_out.GetLength() > 65535)
		MessageBox("Text lenght is over 64k !", "C2Htm", MB_OK | MB_ICONERROR);
	SetDlgItemText(IDC_CODE, str_out);
	EndWaitCursor();

	((CEdit*)GetDlgItem(IDC_CODE))->SetFocus();
	((CEdit*)GetDlgItem(IDC_CODE))->SetSel(0, str_out.GetLength(), false);
	// ozna text ...

	p_progress->SetPos(0);
}

void CC2HtmDlg::OnViewCss()
{
	TProfile t_profile;
	CString str_out;

	GetProfile(&t_profile);
	// nahraje profil z formule ...

	if(t_profile.b_use_table) {
		str_out.Format(
			"<style type=\"text/css\">\r\n"
			".cpp_text {\r\n"
			"\tfont-family : \"Lucida console\", monospace;\r\n"
			"\tfont-size : %dpx;\r\n"
			"\tcolor : #000000;\r\n"
			"}\r\n"
			".cpp_keyword {\r\n"
			"\tfont-family : \"Lucida console\", monospace;\r\n"
			"\tfont-size : %dpx;\r\n"
			"\tcolor : #%06X;\r\n"
			"}\r\n"
			".cpp_comment {\r\n"
			"\tfont-family : \"Lucida console\", monospace;\r\n"
			"\tfont-size : %dpx;\r\n"
			"\tcolor : #%06X;\r\n"
			"}\r\n"
			".cpp {\r\n"
			"\tborder-top-color    : #%06X;\r\n"
			"\tborder-left-color   : #%06X;\r\n"
			"\tborder-right-color  : #%06X;\r\n"
			"\tborder-bottom-color : #%06X;\r\n"
			"\tborder-style : solid;\r\n"
			"}\r\n"
			"</style>\r\n", t_profile.n_font_size, t_profile.n_font_size,
			t_profile.n_keyword_color, t_profile.n_font_size, t_profile.n_comment_color,
			t_profile.n_table_lt_color, t_profile.n_table_lt_color,
			t_profile.n_table_dk_color, t_profile.n_table_dk_color);
	} else {
		str_out.Format(
			"<style type=\"text/css\">\r\n"
			".cpp_text {\r\n"
			"\tfont-family : \"Lucida console\", monospace;\r\n"
			"\tcolor : #000000;\r\n"
			"}\r\n"
			".cpp_keyword {\r\n"
			"\tfont-family : \"Lucida console\", monospace;\r\n"
			"\tcolor : #%06X;\r\n"
			"}\r\n"
			".cpp_comment {\r\n"
			"\tfont-family : \"Lucida console\", monospace;\r\n"
			"\tcolor : #%06X;\r\n"
			"}\r\n"
			".cpp {\r\n"
			"\tfont-size : %dpx;\r\n"
			"\twidth: %d%s;\r\n"
			"\ttext-align: left;\r\n"
			"\tpadding: 3px;\r\n"
			"\tmargin-left: 5%%;\r\n"
			"\tborder: 1px;\r\n"
			"\tborder-style: solid;\r\n"
			"\tborder-color: black;\r\n"
			"}\r\n"
			"</style>\r\n",
			t_profile.n_keyword_color, t_profile.n_comment_color, t_profile.n_font_size,
			t_profile.n_table_width, (t_profile.b_table_width_percent)? "%" : "em");
	}
	//
	SetDlgItemText(IDC_CODE, str_out);
	// zkopruje ablonu

	((CEdit*)GetDlgItem(IDC_CODE))->SetFocus();
	((CEdit*)GetDlgItem(IDC_CODE))->SetSel(0, str_out.GetLength(), false);
	// ozna text ...
}
