// C2HtmDlg.h : header file
//

#if !defined(AFX_C2HTMDLG_H__439E7706_2F2E_11D9_A2FF_A8A2D9F5A25A__INCLUDED_)
#define AFX_C2HTMDLG_H__439E7706_2F2E_11D9_A2FF_A8A2D9F5A25A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CC2HtmDlg dialog

struct TProfileName {
	char *p_s_profile_name;
	char *p_s_profile_file;

	TProfileName() { p_s_profile_name = 0; p_s_profile_file = 0; }
	~TProfileName()
	{
		if(p_s_profile_name)
			delete[] p_s_profile_name;
		if(p_s_profile_file)
			delete[] p_s_profile_file;
		p_s_profile_name = 0;
		p_s_profile_file = 0;
	}
};

struct TProfile {
	int n_tab_size;
	//
	int n_keyword_color;
	int n_comment_color;
	//
	int n_table_lt_color;
	int n_table_dk_color;
	//
	int n_font_size;
	//
	CList<char*> t_keyword_list;
	//
	int n_table_width;
	int b_table_width_percent;
	//
	int b_use_table;

	~TProfile()
	{
		int i;

		for(i = 0; i < t_keyword_list.n_Element_Num(); i ++)
			delete[] *t_keyword_list.p_Element(i);
		t_keyword_list.Clear();
	}

	int Set_Keywords(char *p_s_keywords)
	{
		char *p_s_word;
		int i;

		for(i = 0; i < t_keyword_list.n_Element_Num(); i ++)
			delete[] *t_keyword_list.p_Element(i);
		t_keyword_list.Clear();
		//
		if(!p_s_keywords)
			return true;

		while(strlen(p_s_keywords)) {
			for(i = 0; i < (signed)strlen(p_s_keywords); i ++) {
				if(p_s_keywords[i] == ' ' ||
				   p_s_keywords[i] == '\t' ||
				   p_s_keywords[i] == '\n' ||
				   p_s_keywords[i] == 0)
					break;
			}
			//
			if(!(p_s_word = new char[++ i]))
				return false;
			memcpy(p_s_word, p_s_keywords, i - 1);
			p_s_word[i - 1] = 0;
			if(!strlen(p_s_word))
				continue;
			//
			if(!t_keyword_list.Insert_Element(p_s_word))
				return false;
			//
			if(!*(p_s_keywords + i - 1))
				break;
			p_s_keywords += i;
		}
		// add keywords

		return true;
	}

	int Set_CommentColor(char *p_s_color)
	{
		if(!p_s_color)
			return n_comment_color;
		if(p_s_color[0] == '#')
			p_s_color ++;
		sscanf(p_s_color, "%x", &n_comment_color);

		return n_comment_color;
	}

	int Set_TableLtColor(char *p_s_color)
	{
		if(!p_s_color)
			return n_table_lt_color;
		if(p_s_color[0] == '#')
			p_s_color ++;
		sscanf(p_s_color, "%x", &n_table_lt_color);

		return n_table_lt_color;
	}

	int Set_TableDkColor(char *p_s_color)
	{
		if(!p_s_color)
			return n_table_dk_color;
		if(p_s_color[0] == '#')
			p_s_color ++;
		sscanf(p_s_color, "%x", &n_table_dk_color);

		return n_table_dk_color;
	}

	int Set_KeywordColor(char *p_s_color)
	{
		if(!p_s_color)
			return n_keyword_color;
		if(p_s_color[0] == '#')
			p_s_color ++;
		sscanf(p_s_color, "%x", &n_keyword_color);

		return n_keyword_color;
	}

	char *p_s_Keywords()
	{
		int i, n_len_tot;
		char *p_s_words;

		for(i = 0, n_len_tot = 1; i < t_keyword_list.n_Element_Num(); i ++)
			n_len_tot += 1 + strlen(*t_keyword_list.p_Element(i));
		// total len

		if(!(p_s_words = new char[n_len_tot]))
			return 0;
		p_s_words[0] = 0;
		//
		for(i = 0, n_len_tot = 1; i < t_keyword_list.n_Element_Num(); i ++) {
			if(p_s_words[0])
				strcat(p_s_words, " ");
			strcat(p_s_words, *t_keyword_list.p_Element(i));
		}
		// build string

		return p_s_words;
	}

	char *p_s_CommentColor()
	{
		char *p_col;
		
		if(!(p_col = new char[7]))
			return 0;
		sprintf(p_col, "%06X", n_comment_color & 0xffffff);
		//
		return p_col;
	}

	char *p_s_KeywordColor()
	{
		char *p_col;
		
		if(!(p_col = new char[7]))
			return 0;
		sprintf(p_col, "%06X", n_keyword_color & 0xffffff);
		//
		return p_col;
	}

	char *p_s_TableLtColor()
	{
		char *p_col;
		
		if(!(p_col = new char[7]))
			return 0;
		sprintf(p_col, "%06X", n_table_lt_color & 0xffffff);
		//
		return p_col;
	}

	char *p_s_TableDkColor()
	{
		char *p_col;
		
		if(!(p_col = new char[7]))
			return 0;
		sprintf(p_col, "%06X", n_table_dk_color & 0xffffff);
		//
		return p_col;
	}

	int Save(char *p_s_filename)
	{
		FILE *p_fw;
		int i;

		if(!(p_fw = fopen(p_s_filename, "w")))
			return false;

		fprintf(p_fw, "// profile config v1.00\n// profile_file \"%s\"\n//\n//\n\n", p_s_filename);
		//
		fprintf(p_fw, "n_tab_size = %d;\n\n", n_tab_size);
		//
		fprintf(p_fw, "n_comment_color = 0x%06x;\n", n_comment_color);
		fprintf(p_fw, "n_keyword_color = 0x%06x;\n\n", n_keyword_color);
		//
		fprintf(p_fw, "n_table_lt_color = 0x%06x;\n", n_table_lt_color);
		fprintf(p_fw, "n_table_dk_color = 0x%06x;\n\n", n_table_dk_color);
		//
		fprintf(p_fw, "n_font_size = %d;\n\n", n_font_size);
		//
		fprintf(p_fw, "n_table_width = %d;\n\n", n_table_width);
		fprintf(p_fw, "b_table_width_percent = %d;\n\n", b_table_width_percent);
		//
		fprintf(p_fw, "b_use_table = %d;\n\n", b_use_table);
		//
		fprintf(p_fw, "n_keyword_num = %d;\n", t_keyword_list.n_Element_Num());
		for(i = 0; i < t_keyword_list.n_Element_Num(); i ++)
			fprintf(p_fw, "p_s_keyword[%d] = \"%s\";\n", i, *t_keyword_list.p_Element(i));
		//
		fprintf(p_fw, "\n\n// profile_file \"%s\" end\n", p_s_filename);
		// zape krmy jako ASCII

		fclose(p_fw);

		return true;
	}

	int Load(char *p_s_filename)
	{
		char p_s_tmp[64], *p_s_word;
		int i, n_num, n_len;
		CParser parser;
		FILE *p_fr;

		if(!(p_fr = fopen(p_s_filename, "r")))
			return false;
		if(parser.Parse(p_fr) != Parser_Ok)
			return false;
		fclose(p_fr);
		// parse file

		if(parser.GetValue("n_tab_size", n_tab_size) != Parser_Ok)
			return false;
		//
		if(parser.GetValue("n_comment_color", n_comment_color))
			return false;
		if(parser.GetValue("n_keyword_color", n_keyword_color))
			return false;
		//
		if(parser.GetValue("n_table_lt_color", n_table_lt_color))
			return false;
		if(parser.GetValue("n_table_dk_color", n_table_dk_color))
			return false;
		//
		if(parser.GetValue("n_font_size", n_font_size) != Parser_Ok)
			return false;
		//
		if(parser.GetValue("n_table_width", n_table_width) != Parser_Ok)
			return false;
		if(parser.GetValue("b_table_width_percent", b_table_width_percent) != Parser_Ok)
			return false;
		//
		if(parser.GetValue("b_use_table", b_use_table) != Parser_Ok)
			return false;
		//
		Set_Keywords(0);
		if(parser.GetValue("n_keyword_num", n_num))
			return false;
		for(i = 0; i < n_num; i ++) {
			sprintf(p_s_tmp, "p_s_keyword[%d]", i);
			//
			if(parser.GetStrLength(p_s_tmp, n_len) != Parser_Ok)
				return false;
			if(!(p_s_word = new char[++ n_len]))
				return false;
			if(parser.GetValue(p_s_tmp, p_s_word, n_len))
				return false;
			//
			if(strlen(p_s_word) && !t_keyword_list.Insert_Element(p_s_word))
				return false;
		}
		// read data ...

		parser.Free();

		return true;
	}
};

class CC2HtmDlg : public CDialog
{
// Construction
public:
	CC2HtmDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CC2HtmDlg)
	enum { IDD = IDD_C2HTM_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CC2HtmDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	CList<TProfileName> m_profile_list;
	int m_n_default_profile;

	int LoadProfiles();
	int SaveProfiles();

	void SetProfile(TProfile *p_profile);
	void GetProfile(TProfile *p_profile);

	CFont m_font;

	int m_b_first_time;

	// Generated message map functions
	//{{AFX_MSG(CC2HtmDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnCancel();
	virtual void OnOK();
	afx_msg void OnProfileLoad();
	afx_msg void OnProfileDefaults();
	afx_msg void OnProfileSave();
	afx_msg void OnMakeDefaultProfile();
	afx_msg void OnConvert();
	afx_msg void OnSelendokAvailProfiles();
	afx_msg void OnProfileDelete();
	afx_msg void OnViewCss();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_C2HTMDLG_H__439E7706_2F2E_11D9_A2FF_A8A2D9F5A25A__INCLUDED_)
