/*
								+----------------------------------+
								|                                  |
								| ***  Pashik virtual machine  *** |
								|                                  |
								|   Copyright  -tHE SWINe- 2003   |
								|                                  |
								|              List.h              |
								|                                  |
								+----------------------------------+
*/

#ifndef __LIST_INCLUDED
#define __LIST_INCLUDED

template <class T>
class CList {
	int m_n_buffer_size;
	int m_n_buffer_used;
	//
	T *m_p_buffer;

public:
	CList()
	{
		m_n_buffer_used = 0;
		m_n_buffer_size = 0;
		m_p_buffer = 0;
	}

	~CList()
	{
		if(m_n_buffer_size)
			delete m_p_buffer;
	}
	//
	inline int Insert_Element(T *p_element, int n_count)
	{
		while(n_count) {
			if(m_n_buffer_size == m_n_buffer_used) {
				if(!Grow(50))
					return false;
			}

			m_p_buffer[m_n_buffer_used ++] = *p_element ++;
			n_count --;
		}

		return true;
	}

	inline int Insert_Element(T t_element)
	{
		if(m_n_buffer_size == m_n_buffer_used) {
			if(!Grow(50))
				return false;
		}

		m_p_buffer[m_n_buffer_used ++] = t_element;
	
		return true;
	}

	inline int Append_List(CList<T> &r_list)
	{
		return Insert_Element(r_list.m_p_buffer, r_list.m_n_buffer_used);
	}

	inline int Copy_List(CList<T> &r_list)
	{
		Clear();
		return Insert_Element(r_list.m_p_buffer, r_list.m_n_buffer_used);
	}

	inline int Extend_Buffer(int n_element_num)
	{
		m_n_buffer_used += n_element_num;

		if(m_n_buffer_size < m_n_buffer_used) {
			if(!Grow(m_n_buffer_used - m_n_buffer_size))
				return false;
		}

		return true;
	}
	
	inline int Preserve_Buffer(int n_element_num)
	{
		if(m_n_buffer_used > n_element_num)
			return true;
		m_n_buffer_used = n_element_num;
		if(!Grow(m_n_buffer_used - m_n_buffer_size))
			return false;

		return true;
	}

	inline int Remove_Element(int n_index, int n_count)
	{
		int i, n_first;

		if(n_index < 0 || n_index >= m_n_buffer_used)
			return false;
		if(n_count == -1) {
			m_n_buffer_used = n_index;
			// pokud je -1, odebere a do konce
			return true;
		}

		n_first = n_index + n_count;
		if(n_first >= m_n_buffer_used)
			m_n_buffer_used = n_index;
		else {
			for(i = 0; i < m_n_buffer_used - n_first; i ++)
				m_p_buffer[i + n_index] = m_p_buffer[i + n_first];
			m_n_buffer_used -= n_count;
		}

		return true;
	}

	int Shrink_Buffer()
	{
		T *p_new_buffer;
		int i;

		if(!m_n_buffer_size)
			return false;
		if(m_n_buffer_used == m_n_buffer_size)
			return true;

		if(!(p_new_buffer = new T[m_n_buffer_used]))
			return false;
		for(i = 0; i < m_n_buffer_used; i ++)
			p_new_buffer[i] = m_p_buffer[i];
		m_n_buffer_size = m_n_buffer_used;
		delete[] m_p_buffer;
		m_p_buffer = p_new_buffer;
		// realloc

		return true;
	}
	//
	inline int n_Element_Num()
	{
		return m_n_buffer_used;
	}

	inline T *p_Element(int n_index)
	{
		if(n_index >= 0 && n_index < m_n_buffer_used && m_n_buffer_size)
			return &m_p_buffer[n_index];
		else
			return 0;
	}
	//
	void Clear()
	{
		if(m_n_buffer_size)
			delete[] m_p_buffer;
		//
		m_n_buffer_size = 0;
		m_n_buffer_used = 0;
		m_p_buffer = 0;
	}
	//
	void Serialize(FILE *p_fw)
	{
		fwrite(&m_n_buffer_used, sizeof(T), 1, p_fw);
		fwrite(m_p_buffer, sizeof(T), m_n_buffer_used, p_fw);
	}

	int Load(FILE *p_fr)
	{
		fread(&m_n_buffer_used, sizeof(T), 1, p_fr);

		while(m_n_buffer_size < m_n_buffer_used) {
			if(!Grow(50))
				return false;
		}
		// grows buffer

		fread(m_p_buffer, sizeof(T), m_n_buffer_used, p_fr);

		return true;
	}

protected:
	int Grow(int n_grow)
	{
		T *p_id_buffer;
		int i;

		if(!m_n_buffer_size) {
			if(!(m_p_buffer = new T[n_grow]))
				return 0;
			m_n_buffer_size = n_grow;
			//
			return true;
		}

		if(!(p_id_buffer = new T[m_n_buffer_size + n_grow]))
			return false;
		for(i = 0; i < m_n_buffer_used; i ++)
			p_id_buffer[i] = m_p_buffer[i];
		// nemu pout memcpy, aby se pouily opertory = (pokud je T m)
		m_n_buffer_size += n_grow;
		delete[] m_p_buffer;
		m_p_buffer = p_id_buffer;
		// realloc

		return true;
	}
};


#endif // __LIST_INCLUDED